﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

using HSVSpace;



namespace HSV2RGB_Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        bool running;

        private void button1_Click(object sender, EventArgs e)
        {
            if (running)
            {
                running = false;
                stopping = true;
                button1.Text = "Start";
                return;
            }

            this.Focus();
            running = true;
            button1.Text = "Stop";


            int za1 = 0;
            int za2 = 0;
            int za3 = 0;


            HSVColor HSVcolor = new HSVColor();
            HSVColorAVR HSVcolorAVR = new HSVColorAVR();

            RGBColorAVR RGBcolorAVR = new RGBColorAVR();
            RGBColor RGBcolor = new RGBColor();


            Stopwatch sw = new Stopwatch();
            sw.Restart();

            int h = 0, s = 0, v = 0;

            for (h = 0; h < 256; h++)
            {
                for (s = 0; s < 256; s++)
                {
                    for (v = 0; v < 256; v++)
                    {
                        HSVcolorAVR.H = (Byte)h;
                        HSVcolorAVR.S = (Byte)s;
                        HSVcolorAVR.V = (Byte)v;

                        RGBcolorAVR = HSV2RGBAVR.Convert(HSVcolorAVR);

                        HSVcolor.H = h * 360f / 256f;
                        HSVcolor.S = s / 255f;
                        HSVcolor.V = v / 255f;

                        RGBcolor = HSV2RGB.Convert(HSVcolor);

                        int ar = Math.Abs(RGBcolorAVR.R - RGBcolor.ByteR);
                        int ag = Math.Abs(RGBcolorAVR.G - RGBcolor.ByteG);
                        int ab = Math.Abs(RGBcolorAVR.B - RGBcolor.ByteB);

                        if ((ar == 1) || (ag == 1) || (ab == 1))
                        {
                            ++za1;
                        }

                        if ((ar == 2) || (ag == 2) || (ab == 2))
                        {
                            ++za2;
                        }

                        if ((ar == 3) || (ag == 3) || (ab == 3))
                        {
                            ++za3;
                        }


                        // Anzeige Updaten
                        if (sw.ElapsedMilliseconds >= 100)
                        {
                            sw.Restart();

                            lb_h.Text = String.Format("H {0:000}", h);
                            lb_s.Text = String.Format("S {0:000}", s);
                            lb_v.Text = String.Format("V {0:000}", v);

                            lb_r1.Text = String.Format("Rb {0:000}", RGBcolorAVR.R);
                            lb_g1.Text = String.Format("Gb {0:000}", RGBcolorAVR.G);
                            lb_b1.Text = String.Format("Bb {0:000}", RGBcolorAVR.B);

                            lb_r2.Text = String.Format("Rf {0:000}", RGBcolor.ByteR);
                            lb_g2.Text = String.Format("Gf {0:000}", RGBcolor.ByteG);
                            lb_b2.Text = String.Format("Bf {0:000}", RGBcolor.ByteB);

                            lb_za1.Text = "D1 " + za1.ToString();
                            lb_za2.Text = "D2 " + za2.ToString();
                            lb_za3.Text = "D3 " + za3.ToString();

                            Application.DoEvents();
                        }


                        if ((ar > 3) || (ag > 3) || (ab > 3))
                        {
                            lb_h.Text = String.Format("H {0:000}", h);
                            lb_s.Text = String.Format("S {0:000}", s);
                            lb_v.Text = String.Format("V {0:000}", v);

                            lb_r1.Text = String.Format("Rb {0:000}", RGBcolorAVR.R);
                            lb_g1.Text = String.Format("Gb {0:000}", RGBcolorAVR.G);
                            lb_b1.Text = String.Format("Bb {0:000}", RGBcolorAVR.B);

                            lb_r2.Text = String.Format("Rf {0:000}", RGBcolor.ByteR);
                            lb_g2.Text = String.Format("Gf {0:000}", RGBcolor.ByteG);
                            lb_b2.Text = String.Format("Bf {0:000}", RGBcolor.ByteB);

                            lb_za1.Text = "D1 " + za1.ToString();
                            lb_za2.Text = "D2 " + za2.ToString();
                            lb_za3.Text = "D3 " + za3.ToString();

                            Application.DoEvents();

                            RGBcolorAVR = HSV2RGBAVR.Convert(HSVcolorAVR);

                            MessageBox.Show("Error diviation > 3");
                            return;
                        }

                        if (stopping)
                        {
                            stopping = false;
                            return;
                        }

                    }
                }
            }

            lb_h.Text = String.Format("H {0:000}", h-1);
            lb_s.Text = String.Format("S {0:000}", s-1);
            lb_v.Text = String.Format("V {0:000}", v-1);

            lb_r1.Text = String.Format("Rb {0:000}", RGBcolorAVR.R);
            lb_g1.Text = String.Format("Gb {0:000}", RGBcolorAVR.G);
            lb_b1.Text = String.Format("Bb {0:000}", RGBcolorAVR.B);

            lb_r2.Text = String.Format("Rf {0:000}", RGBcolor.ByteR);
            lb_g2.Text = String.Format("Gf {0:000}", RGBcolor.ByteG);
            lb_b2.Text = String.Format("Bf {0:000}", RGBcolor.ByteB);

            lb_za1.Text = "D1 " + za1.ToString();
            lb_za2.Text = "D2 " + za2.ToString();
            lb_za3.Text = "D3 " + za3.ToString();

            running = false;
            button1.Text = "Start";
        }


        private bool stopping;

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            stopping = true;
        }
    }
}
